Index: /pjproject/trunk/pjsip/src/pjsip/sip_msg.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 4537)
@@ -400,5 +400,5 @@
 {
     char *p=buf, *end=buf+size;
-    int len;
+    pj_size_t len;
     pjsip_hdr *hdr;
     pj_str_t clen_hdr =  { "Content-Length: ", 16};
@@ -498,5 +498,5 @@
 	    pj_memcpy(p, ctype_hdr.ptr, ctype_hdr.slen);
 	    p += ctype_hdr.slen;
-	    p += print_media_type(p, end-p, media);
+	    p += print_media_type(p, (unsigned)(end-p), media);
 	    *p++ = '\r';
 	    *p++ = '\n';
@@ -536,5 +536,5 @@
 	if (clen_pos) {
 	    char tmp[16];
-	    len = pj_utoa(len, tmp);
+	    len = pj_utoa((unsigned long)len, tmp);
 	    if (len > CLEN_SPACE) len = CLEN_SPACE;
 	    pj_memcpy(clen_pos+CLEN_SPACE-len, tmp, len);
@@ -763,5 +763,5 @@
     *p = '\0';
 
-    return p - buf;
+    return (int)(p - buf);
 }
 
@@ -845,5 +845,5 @@
     p += pj_utoa(hdr->ivalue, p);
 
-    return p - buf;
+    return (int)(p - buf);
 }
 
@@ -924,5 +924,5 @@
     }
 
-    return p - buf;
+    return (int)(p - buf);
 }
 
@@ -1072,5 +1072,5 @@
     *p = '\0';
 
-    return p-buf;
+    return (int)(p-buf);
 }
 
@@ -1142,5 +1142,5 @@
     *p = '\0';
 
-    return p-buf;
+    return (int)(p-buf);
 }
 
@@ -1213,5 +1213,5 @@
 	*p++ = ' ';
 	*p++ = '*';
-	return p - buf;
+	return (int)(p - buf);
 
     } else {
@@ -1263,13 +1263,13 @@
 	}
 
-	printed = pjsip_param_print_on(&hdr->other_param, buf, endbuf-buf,
-				       &pc->pjsip_TOKEN_SPEC,
-				       &pc->pjsip_TOKEN_SPEC, 
-				       ';');
+	printed = (int)pjsip_param_print_on(&hdr->other_param, buf, endbuf-buf,
+					    &pc->pjsip_TOKEN_SPEC,
+					    &pc->pjsip_TOKEN_SPEC, 
+					    ';');
 	if (printed < 0)
 	    return printed;
 	buf += printed;
 
-	return buf-startbuf;
+	return (int)(buf-startbuf);
     }
 }
@@ -1360,5 +1360,5 @@
     p += printed;
 
-    return p-buf;
+    return (int)(p-buf);
 }
 
@@ -1388,9 +1388,9 @@
     *p++ = ' ';
 
-    len = print_media_type(p, buf+size-p, &hdr->media);
+    len = print_media_type(p, (unsigned)(buf+size-p), &hdr->media);
     p += len;
 
     *p = '\0';
-    return p-buf;
+    return (int)(p-buf);
 }
 
@@ -1512,5 +1512,5 @@
 				   char *buf, pj_size_t size)
 {
-    int printed;
+    pj_ssize_t printed;
     char *startbuf = buf;
     char *endbuf = buf + size;
@@ -1539,5 +1539,5 @@
     buf += printed;
 
-    return buf-startbuf;
+    return (int)(buf-startbuf);
 }
 
@@ -1693,5 +1693,5 @@
 				    char *buf, pj_size_t size )
 {
-    int printed;
+    pj_ssize_t printed;
     char *startbuf = buf;
     char *endbuf = buf + size;
@@ -1735,5 +1735,5 @@
     buf += printed;
 
-    return buf-startbuf;
+    return (int)(buf-startbuf);
 }
 
@@ -1832,5 +1832,5 @@
     const pj_str_t *hname = &hdr->name;
     const pjsip_parser_const_t *pc = pjsip_parser_const();
-    int printed;
+    pj_ssize_t printed;
     
     if ((pj_ssize_t)size < hdr->name.slen + 2+11)
@@ -1867,9 +1867,9 @@
 				   ';');
     if (printed < 0)
-	return printed;
+	return (int)printed;
 
     p += printed;
 
-    return p - buf;
+    return (int)(p - buf);
 }
 
@@ -1977,5 +1977,5 @@
 				char *buf, pj_size_t size)
 {
-    int printed;
+    pj_ssize_t printed;
     char *startbuf = buf;
     char *endbuf = buf + size;
@@ -2065,5 +2065,5 @@
     buf += printed;
     
-    return buf-startbuf;
+    return (int)(buf-startbuf);
 }
 
@@ -2209,5 +2209,5 @@
     body->data = pj_pool_alloc(pool, text->slen);
     pj_memcpy(body->data, text->ptr, text->slen);
-    body->len = text->slen;
+    body->len = (unsigned)text->slen;
 
     body->clone_data = &pjsip_clone_text_data;
Index: /pjproject/trunk/pjsip/src/pjsip/sip_multipart.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_multipart.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_multipart.c	(revision 4537)
@@ -110,5 +110,5 @@
 	    pj_memcpy(p, ctype_hdr.ptr, ctype_hdr.slen);
 	    p += ctype_hdr.slen;
-	    p += pjsip_media_type_print(p, end-p, media);
+	    p += pjsip_media_type_print(p, (unsigned)(end-p), media);
 	    *p++ = '\r';
 	    *p++ = '\n';
@@ -169,5 +169,5 @@
 #undef SIZE_LEFT
 
-    return p - buf;
+    return (int)(p - buf);
 }
 
@@ -490,5 +490,5 @@
     if (start_body < end) {
 	part->body->data = start_body;
-	part->body->len = end - start_body;
+	part->body->len = (unsigned)(end - start_body);
     } else {
 	part->body->data = (void*)"";
Index: /pjproject/trunk/pjsip/src/pjsip/sip_parser.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_parser.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_parser.c	(revision 4537)
@@ -246,5 +246,5 @@
 {
     char *new_param, *p;
-    int len;
+    pj_size_t len;
 
     len = param->slen + pname->slen + pvalue->slen + 3;
@@ -252,5 +252,5 @@
     
     if (param->slen) {
-	int old_len = param->slen;
+	pj_size_t old_len = param->slen;
 	pj_memcpy(p, param->ptr, old_len);
 	p += old_len;
@@ -561,5 +561,5 @@
 
     /* Calculate hash value. */
-    rec.hname_hash = pj_hash_calc(0, rec.hname, rec.hname_len);
+    rec.hname_hash = pj_hash_calc(0, rec.hname, (unsigned)rec.hname_len);
 
     /* Get the pos to insert the new handler. */
@@ -596,5 +596,6 @@
 					       pjsip_parse_hdr_func *fptr)
 {
-    unsigned i, len;
+    unsigned i;
+    pj_size_t len;
     char hname_lcase[PJSIP_MAX_HNAME_LEN+1];
     pj_status_t status;
@@ -682,5 +683,5 @@
 
     /* First, common case, try to find handler with exact name */
-    hash = pj_hash_calc(0, hname->ptr, hname->slen);
+    hash = pj_hash_calc(0, hname->ptr, (unsigned)hname->slen);
     handler = find_handler_imp(hash, hname);
     if (handler)
@@ -1065,5 +1066,5 @@
 
 		body->data = scanner->curptr;
-		body->len = scanner->end - scanner->curptr;
+		body->len = (unsigned)(scanner->end - scanner->curptr);
 		body->print_body = &pjsip_print_text_body;
 		body->clone_data = &pjsip_clone_text_data;
@@ -2279,5 +2280,5 @@
 
     if (parsed_len) {
-	*parsed_len = (scanner.curptr - scanner.begin);
+	*parsed_len = (unsigned)(scanner.curptr - scanner.begin);
     }
 
Index: /pjproject/trunk/pjsip/src/pjsip/sip_tel_uri.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_tel_uri.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_tel_uri.c	(revision 4537)
@@ -211,7 +211,7 @@
 
     /* Print other parameters. */
-    printed = pjsip_param_print_on(&uri->other_param, buf, (endbuf-buf), 
-				   &pjsip_TEL_PNAME_SPEC, 
-				   &pjsip_TEL_PVALUE_SPEC, ';');
+    printed = (int)pjsip_param_print_on(&uri->other_param, buf, (endbuf-buf), 
+					&pjsip_TEL_PNAME_SPEC, 
+					&pjsip_TEL_PVALUE_SPEC, ';');
     if (printed < 0)
 	return -1;
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 4537)
@@ -273,5 +273,5 @@
 #define SEPARATOR   '$'
     char *key, *p;
-    int len;
+    pj_ssize_t len;
     pj_size_t len_required;
     pj_str_t *host;
@@ -542,5 +542,5 @@
     if(pj_hash_get_lower(mod_tsx_layer.htable, 
 		         tsx->transaction_key.ptr,
-		         tsx->transaction_key.slen, 
+		         (unsigned)tsx->transaction_key.slen, 
 		         NULL))
     {
@@ -562,5 +562,6 @@
     pj_hash_set_lower( tsx->pool, mod_tsx_layer.htable,
                        tsx->transaction_key.ptr,
-    		       tsx->transaction_key.slen, tsx->hashed_key, tsx);
+    		       (unsigned)tsx->transaction_key.slen, 
+		       tsx->hashed_key, tsx);
 #else
     pj_hash_set_lower( tsx->pool, mod_tsx_layer.htable,
@@ -599,5 +600,6 @@
 #ifdef PRECALC_HASH
     pj_hash_set_lower( NULL, mod_tsx_layer.htable, tsx->transaction_key.ptr,
-    		       tsx->transaction_key.slen, tsx->hashed_key, NULL);
+    		       (unsigned)tsx->transaction_key.slen, tsx->hashed_key, 
+		       NULL);
 #else
     pj_hash_set_lower( NULL, mod_tsx_layer.htable, tsx->transaction_key.ptr,
@@ -645,6 +647,6 @@
     pj_mutex_lock(mod_tsx_layer.mutex);
     tsx = (pjsip_transaction*)
-    	  pj_hash_get_lower( mod_tsx_layer.htable, key->ptr, key->slen,
-                             &hval );
+    	  pj_hash_get_lower( mod_tsx_layer.htable, key->ptr, 
+			     (unsigned)key->slen, &hval );
     pj_mutex_unlock(mod_tsx_layer.mutex);
 
@@ -779,5 +781,6 @@
 
     tsx = (pjsip_transaction*) 
-    	  pj_hash_get_lower( mod_tsx_layer.htable, key.ptr, key.slen, &hval );
+    	  pj_hash_get_lower( mod_tsx_layer.htable, key.ptr, (unsigned)key.slen, 
+			     &hval );
 
 
@@ -829,5 +832,6 @@
 
     tsx = (pjsip_transaction*) 
-    	  pj_hash_get_lower( mod_tsx_layer.htable, key.ptr, key.slen, &hval );
+    	  pj_hash_get_lower( mod_tsx_layer.htable, key.ptr, (unsigned)key.slen, 
+			     &hval );
 
 
@@ -1846,7 +1850,7 @@
 	    pj_str_t err;
 
-	    tsx->transport_err = -sent;
-
-	    err =pj_strerror(-sent, errmsg, sizeof(errmsg));
+	    tsx->transport_err = (pj_status_t)-sent;
+
+	    err =pj_strerror((pj_status_t)-sent, errmsg, sizeof(errmsg));
 
 	    PJ_LOG(2,(tsx->obj_name,
@@ -1888,5 +1892,5 @@
 
 	} else {
-	    PJ_PERROR(2,(tsx->obj_name, -sent,
+	    PJ_PERROR(2,(tsx->obj_name, (pj_status_t)-sent,
 		         "Temporary failure in sending %s, "
 		         "will try next server",
@@ -1935,5 +1939,5 @@
 	char errmsg[PJ_ERR_MSG_SIZE];
 
-	pj_strerror(-sent, errmsg, sizeof(errmsg));
+	pj_strerror((pj_status_t)-sent, errmsg, sizeof(errmsg));
 
 	PJ_LOG(2,(tsx->obj_name, "Transport failed to send %s! Err=%d (%s)",
@@ -1944,5 +1948,5 @@
 	 */
 	lock_timer(tsx);
-	tsx->transport_err = -sent;
+	tsx->transport_err = (pj_status_t)-sent;
 	tsx_cancel_timer(tsx, &tsx->timeout_timer);
 	tsx_schedule_timer(tsx, &tsx->timeout_timer, &delay,
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 4537)
@@ -1627,5 +1627,5 @@
 	pj_list_init(&rdata->msg_info.parse_err);
 	rdata->msg_info.msg_buf = current_pkt;
-	rdata->msg_info.len = remaining_len;
+	rdata->msg_info.len = (int)remaining_len;
 
 	/* For TCP transport, check if the whole message has been received. */
@@ -1647,5 +1647,5 @@
 
 	/* Update msg_info. */
-	rdata->msg_info.len = msg_fragment_size;
+	rdata->msg_info.len = (int)msg_fragment_size;
 
 	/* Null terminate packet */
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport_tcp.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport_tcp.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport_tcp.c	(revision 4537)
@@ -827,5 +827,5 @@
 {
     pj_pool_t *pool;
-    pj_ssize_t size;
+    pj_uint32_t size;
     pj_sockaddr *rem_addr;
     void *readbuf[1];
@@ -1114,5 +1114,5 @@
 
 	status = (bytes_sent == 0) ? PJ_RETURN_OS_ERROR(OSERR_ENOTCONN) :
-				     -bytes_sent;
+				     (pj_status_t)-bytes_sent;
 
 	tcp_init_shutdown(tcp, status);
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport_tls.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport_tls.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport_tls.c	(revision 4537)
@@ -835,5 +835,5 @@
 {
     pj_pool_t *pool;
-    pj_ssize_t size;
+    pj_uint32_t size;
     pj_sockaddr *rem_addr;
     void *readbuf[1];
@@ -1220,5 +1220,5 @@
 
 	status = (bytes_sent == 0) ? PJ_RETURN_OS_ERROR(OSERR_ENOTCONN) :
-				     -bytes_sent;
+				     (pj_status_t)-bytes_sent;
 
 	tls_init_shutdown(tls, status);
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c	(revision 4537)
@@ -97,5 +97,5 @@
     rdata->tp_info.pool = pool;
     rdata->tp_info.transport = &tp->base;
-    rdata->tp_info.tp_data = (void*)(long)rdata_index;
+    rdata->tp_info.tp_data = (void*)(pj_ssize_t)rdata_index;
     rdata->tp_info.op_key.rdata = rdata;
     pj_ioqueue_op_key_init(&rdata->tp_info.op_key.op_key, 
@@ -194,5 +194,5 @@
 	    PJSIP_ENDPT_LOG_ERROR((rdata->tp_info.transport->endpt,
 				   rdata->tp_info.transport->obj_name,
-				   -bytes_read, 
+				   (pj_status_t)-bytes_read, 
 				   "Warning: pj_ioqueue_recvfrom()"
 				   " callback error"));
@@ -216,5 +216,6 @@
 
 	    rdata_tp = (struct udp_transport*)rdata->tp_info.transport;
-	    rdata_index = (unsigned)(unsigned long)rdata->tp_info.tp_data;
+	    rdata_index = (unsigned)(unsigned long)(pj_ssize_t)
+			  rdata->tp_info.tp_data;
 
 	    pj_pool_reset(rdata_pool);
Index: /pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c	(revision 4537)
@@ -305,5 +305,5 @@
 		  pj_hash_get_lower( mod_ua.dlg_table,
                                      dlg->local.info->tag.ptr, 
-			             dlg->local.info->tag.slen,
+			             (unsigned)dlg->local.info->tag.slen,
 			             &dlg->local.tag_hval);
 
@@ -330,5 +330,5 @@
 	    pj_hash_set_np_lower(mod_ua.dlg_table, 
 			         dlg->local.info->tag.ptr,
-                                 dlg->local.info->tag.slen,
+                                 (unsigned)dlg->local.info->tag.slen,
 			         dlg->local.tag_hval, dlg_set->ht_entry,
                                  dlg_set);
@@ -347,5 +347,5 @@
 	pj_hash_set_np_lower(mod_ua.dlg_table, 
 		             dlg->local.info->tag.ptr,
-                             dlg->local.info->tag.slen,
+                             (unsigned)dlg->local.info->tag.slen,
 		             dlg->local.tag_hval, dlg_set->ht_entry, dlg_set);
     }
@@ -393,6 +393,6 @@
     if (pj_list_empty(&dlg_set->dlg_list)) {
 	pj_hash_set_lower(NULL, mod_ua.dlg_table, dlg->local.info->tag.ptr,
-		          dlg->local.info->tag.slen, dlg->local.tag_hval,
-                          NULL);
+		          (unsigned)dlg->local.info->tag.slen, 
+			  dlg->local.tag_hval, NULL);
 
 	/* Return dlg_set to free nodes. */
@@ -456,5 +456,5 @@
     dlg_set = (struct dlg_set*)
     	      pj_hash_get_lower(mod_ua.dlg_table, local_tag->ptr,
-                                local_tag->slen, NULL);
+                                (unsigned)local_tag->slen, NULL);
     if (dlg_set == NULL) {
 	/* Not found */
@@ -569,6 +569,6 @@
 	/* Lookup the dialog set. */
 	dlg_set = (struct dlg_set*)
-		  pj_hash_get_lower(mod_ua.dlg_table, tag->ptr, tag->slen,
-                                    NULL);
+		  pj_hash_get_lower(mod_ua.dlg_table, tag->ptr, 
+				    (unsigned)tag->slen, NULL);
 	return dlg_set;
     }
@@ -770,5 +770,5 @@
 		  pj_hash_get_lower(mod_ua.dlg_table, 
 			            rdata->msg_info.from->tag.ptr,
-			            rdata->msg_info.from->tag.slen,
+			            (unsigned)rdata->msg_info.from->tag.slen,
 			            NULL);
 
Index: /pjproject/trunk/pjsip/src/pjsip/sip_uri.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_uri.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_uri.c	(revision 4537)
@@ -359,7 +359,7 @@
 
     /* Other param. */
-    printed = pjsip_param_print_on(&url->other_param, buf, endbuf-buf, 
-				   &pc->pjsip_PARAM_CHAR_SPEC, 
-				   &pc->pjsip_PARAM_CHAR_SPEC, ';');
+    printed = (int)pjsip_param_print_on(&url->other_param, buf, endbuf-buf, 
+					&pc->pjsip_PARAM_CHAR_SPEC, 
+					&pc->pjsip_PARAM_CHAR_SPEC, ';');
     if (printed < 0)
 	return -1;
@@ -372,7 +372,7 @@
      */
     if (context == PJSIP_URI_IN_CONTACT_HDR || context == PJSIP_URI_IN_OTHER) {
-	printed = pjsip_param_print_on(&url->header_param, buf, endbuf-buf,
-				       &pc->pjsip_HDR_CHAR_SPEC, 
-				       &pc->pjsip_HDR_CHAR_SPEC, '?');
+	printed = (int)pjsip_param_print_on(&url->header_param, buf, endbuf-buf,
+					    &pc->pjsip_HDR_CHAR_SPEC, 
+					    &pc->pjsip_HDR_CHAR_SPEC, '?');
 	if (printed < 0)
 	    return -1;
Index: /pjproject/trunk/pjsip/src/pjsip/sip_util.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_util.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_util.c	(revision 4537)
@@ -275,5 +275,5 @@
 	body->data = pj_pool_alloc(tdata->pool, param_text->slen );
 	pj_memcpy(body->data, param_text->ptr, param_text->slen);
-	body->len = param_text->slen;
+	body->len = (unsigned)param_text->slen;
 	body->print_body = &pjsip_print_text_body;
 	msg->body = body;
@@ -1302,5 +1302,5 @@
 
 	/* Check if request message is larger than 1300 bytes. */
-	len = tdata->buf.cur - tdata->buf.start;
+	len = (int)(tdata->buf.cur - tdata->buf.start);
 	if (len >= PJSIP_UDP_SIZE_THRESHOLD) {
 	    int i;
Index: /pjproject/trunk/pjsip/src/pjsip/sip_util_proxy.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_util_proxy.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_util_proxy.c	(revision 4537)
@@ -371,5 +371,5 @@
     pj_md5_init(&ctx);
     pj_md5_update(&ctx, (pj_uint8_t*)rdata->msg_info.via->branch_param.ptr,
-		  rdata->msg_info.via->branch_param.slen);
+		  (unsigned)rdata->msg_info.via->branch_param.slen);
     pj_md5_final(&ctx, digest);
 
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_acc.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_acc.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_acc.c	(revision 4537)
@@ -300,5 +300,5 @@
 #if PJSUA_ADD_ICE_TAGS
     if (acc_cfg->ice_cfg.enable_ice) {
-	unsigned new_len;
+	pj_ssize_t new_len;
 	pj_str_t new_prm;
 
@@ -321,10 +321,11 @@
 	if (acc_cfg->rfc5626_instance_id.slen==0) {
 	    const pj_str_t *hostname;
-	    pj_uint32_t hval, pos;
+	    pj_uint32_t hval;
+	    pj_size_t pos;
 	    char instprm[] = ";+sip.instance=\"<urn:uuid:00000000-0000-0000-0000-0000CCDDEEFF>\"";
 
 	    hostname = pj_gethostname();
 	    pos = pj_ansi_strlen(instprm) - 10;
-	    hval = pj_hash_calc(0, hostname->ptr, hostname->slen);
+	    hval = pj_hash_calc(0, hostname->ptr, (unsigned)hostname->slen);
 	    pj_val_to_hex_digit( ((char*)&hval)[0], instprm+pos+0);
 	    pj_val_to_hex_digit( ((char*)&hval)[1], instprm+pos+2);
@@ -335,5 +336,5 @@
 	} else {
 	    const char *prmname = ";+sip.instance=\"";
-	    unsigned len;
+	    pj_size_t len;
 
 	    len = pj_ansi_strlen(prmname) + acc_cfg->rfc5626_instance_id.slen + 1;
@@ -351,5 +352,5 @@
 	} else {
 	    const char *prmname = ";reg-id=";
-	    unsigned len;
+	    pj_size_t len;
 
 	    len = pj_ansi_strlen(prmname) + acc_cfg->rfc5626_reg_id.slen;
@@ -998,5 +999,6 @@
     /* Global outbound proxy */
     if (global_route_crc != acc->global_route_crc) {
-	unsigned i, rcnt;
+	unsigned i;
+	pj_size_t rcnt;
 
 	/* Remove the outbound proxies from the route set */
@@ -1363,5 +1365,5 @@
 	 * reg-id parameters.
 	 */
-	unsigned len;
+	pj_ssize_t len;
 	pj_str_t reg_contact;
 
@@ -1683,5 +1685,6 @@
     const pj_str_t HROUTE = { "Route", 5 };
     pjsip_uri *uri[PJSUA_ACC_MAX_PROXIES];
-    unsigned i, uri_cnt = 0, rcnt;
+    unsigned i, uri_cnt = 0;
+    pj_size_t rcnt;
 
     /* Find and parse Service-Route headers */
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_aud.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_aud.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_aud.c	(revision 4537)
@@ -555,5 +555,5 @@
 	pjsua_call_id call_id;
 
-	call_id = (pjsua_call_id)(long)user_data;
+	call_id = (pjsua_call_id)(pj_ssize_t)user_data;
 	pjsua_var.ua_cfg.cb.on_dtmf_digit(call_id, digit);
     }
@@ -639,5 +639,5 @@
 	    pjmedia_stream_set_dtmf_callback(call_med->strm.a.stream,
 					     &dtmf_callback,
-					     (void*)(long)(call->index));
+					     (void*)(pj_ssize_t)(call->index));
 	}
 
@@ -1047,5 +1047,6 @@
     path[filename->slen] = '\0';
 
-    pool = pjsua_pool_create(get_basename(path, filename->slen), 1000, 1000);
+    pool = pjsua_pool_create(get_basename(path, (unsigned)filename->slen), 1000, 
+			     1000);
     if (!pool) {
 	status = PJ_ENOMEM;
@@ -1335,5 +1336,6 @@
     path[filename->slen] = '\0';
 
-    pool = pjsua_pool_create(get_basename(path, filename->slen), 1000, 1000);
+    pool = pjsua_pool_create(get_basename(path, (unsigned)filename->slen), 1000, 
+			     1000);
     if (!pool) {
 	status = PJ_ENOMEM;
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 4537)
@@ -387,5 +387,5 @@
     if (status != PJ_SUCCESS) {
 	pj_str_t err_str;
-	int title_len;
+	pj_ssize_t title_len;
 
 	call->last_code = PJSIP_SC_TEMPORARILY_UNAVAILABLE;
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 4537)
@@ -86,5 +86,5 @@
 		 PJ_LOG_HAS_SPACE | PJ_LOG_HAS_THREAD_SWC |
 		 PJ_LOG_HAS_INDENT;
-#if defined(PJ_WIN32) && PJ_WIN32 != 0
+#if (defined(PJ_WIN32) && PJ_WIN32 != 0) || (defined(PJ_WIN64) && PJ_WIN64 != 0)
     cfg->decor |= PJ_LOG_HAS_COLOR;
 #endif
@@ -2680,5 +2680,5 @@
     pj_pool_t *pool;
     char *url;
-    int len = (c_url ? pj_ansi_strlen(c_url) : 0);
+    pj_size_t len = (c_url ? pj_ansi_strlen(c_url) : 0);
 
     if (!len) return PJSIP_EINVALIDURI;
@@ -2704,5 +2704,5 @@
     pj_pool_t *pool;
     char *url;
-    int len = (c_url ? pj_ansi_strlen(c_url) : 0);
+    pj_size_t len = (c_url ? pj_ansi_strlen(c_url) : 0);
 
     if (!len) return PJSIP_EINVALIDURI;
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_dump.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_dump.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_dump.c	(revision 4537)
@@ -131,5 +131,5 @@
     if (len < 1 || len > end-p) {
 	*p = '\0';
-	return (p-buf);
+	return (unsigned)(p-buf);
     }
     p += len;
@@ -189,5 +189,5 @@
     if (len < 1 || len > end-p) {
 	*p = '\0';
-	return (p-buf);
+	return (unsigned)(p-buf);
     }
     p += len;
@@ -204,9 +204,9 @@
     if (len < 1 || len > end-p) {
 	*p = '\0';
-	return (p-buf);
+	return (unsigned)(p-buf);
     }
     p += len;
 
-    return (p-buf);
+    return (unsigned)(p-buf);
 }
 
@@ -448,5 +448,5 @@
 
 	if (has_stat) {
-	    len = dump_media_stat(indent, p, end-p, &stat,
+	    len = dump_media_stat(indent, p, (unsigned)(end-p), &stat,
 				  rx_info, tx_info);
 	    p += len;
@@ -949,5 +949,5 @@
     print_call(indent, call_id, tmp, sizeof(tmp));
 
-    len = pj_ansi_strlen(tmp);
+    len = (int)pj_ansi_strlen(tmp);
     pj_ansi_strcpy(buffer, tmp);
 
@@ -994,5 +994,5 @@
     /* Dump session statistics */
     if (with_media)
-	dump_media_session(indent, p, end-p, call);
+	dump_media_session(indent, p, (unsigned)(end-p), call);
 
     pjsip_dlg_dec_lock(dlg);
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 4537)
@@ -593,5 +593,5 @@
 static void ice_failed_nego_cb(void *user_data)
 {
-    int call_id = (int)(long)user_data;
+    int call_id = (int)(pj_ssize_t)user_data;
     pjsua_call *call = NULL;
     pjsip_dialog *dlg = NULL;
@@ -642,5 +642,5 @@
 		/* Defer the callback to a timer */
 		pjsua_schedule_timer2(&ice_failed_nego_cb,
-				      (void*)(long)call->index, 1);
+				      (void*)(pj_ssize_t)call->index, 1);
 	    }
         }
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_pres.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_pres.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_pres.c	(revision 4537)
@@ -224,5 +224,5 @@
 					  pjsua_buddy_info *info)
 {
-    unsigned total=0;
+    pj_size_t total=0;
     struct buddy_lock lck;
     pjsua_buddy *buddy;
@@ -1066,5 +1066,5 @@
 
     PJ_LOG(4,(THIS_FILE, "Acc %d: sending NOTIFY for srv_pres=0x%p..",
-	      acc_id, (int)(long)srv_pres));
+	      acc_id, (int)(pj_ssize_t)srv_pres));
     pj_log_push_indent();
 
Index: /pjproject/trunk/pjsip/src/test/msg_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test/msg_test.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/test/msg_test.c	(revision 4537)
@@ -248,5 +248,5 @@
     static pjsip_msg *print_msg;
     pj_status_t status = PJ_SUCCESS;
-    int len;
+    pj_ssize_t len;
     pj_str_t str1, str2;
     pjsip_hdr *hdr1, *hdr2;
@@ -810,5 +810,5 @@
 	"m=audio 3456 RTP/AVP 0 1 3 99\r\n"
 	"a=rtpmap:0 PCMU/8000\r\n";
-    body->len = pj_ansi_strlen((const char*) body->data);
+    body->len = (unsigned)pj_ansi_strlen((const char*) body->data);
     body->print_body = &pjsip_print_text_body;
 
@@ -1889,5 +1889,6 @@
 	struct hdr_test_t  *test = &hdr_test_data[i];
 	pj_str_t hname;
-	int len, parsed_len;
+	pj_size_t len;
+	int parsed_len;
 	pj_pool_t *pool;
 	pjsip_hdr *parsed_hdr1=NULL, *parsed_hdr2=NULL;
@@ -1995,5 +1996,6 @@
 	unsigned print;
     } run[COUNT];
-    unsigned i, max, avg_len;
+    unsigned i, max;
+    int avg_len;
     char desc[250];
     pj_status_t status;
@@ -2017,5 +2019,5 @@
     /* Calculate average message length */
     for (i=0, avg_len=0; i<PJ_ARRAY_SIZE(test_array); ++i) {
-	avg_len += test_array[i].len;
+	avg_len += (int)test_array[i].len;
     }
     avg_len /= PJ_ARRAY_SIZE(test_array);
Index: /pjproject/trunk/pjsip/src/test/transport_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test/transport_test.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/test/transport_test.c	(revision 4537)
@@ -164,5 +164,5 @@
     if (sent < 1) {
 	/* Obtain the error code. */
-	send_status = -sent;
+	send_status = (int)-sent;
     } else {
 	send_status = PJ_SUCCESS;
@@ -416,5 +416,5 @@
     }
     timeout_delay.sec = 100; timeout_delay.msec = 0;
-    rt_test_data[thread_id].timeout_timer.user_data = (void*)1;
+    rt_test_data[thread_id].timeout_timer.user_data = (void*)(pj_ssize_t)1;
     pjsip_endpt_schedule_timer(endpt, &rt_test_data[thread_id].timeout_timer,
 			       &timeout_delay);
@@ -446,5 +446,5 @@
 	    pj_time_val tx_delay = { 0, 0 };
 	    pj_assert(rt_test_data[thread_id].tx_timer.user_data == NULL);
-	    rt_test_data[thread_id].tx_timer.user_data = (void*)1;
+	    rt_test_data[thread_id].tx_timer.user_data = (void*)(pj_ssize_t)1;
 	    pjsip_endpt_schedule_timer(endpt, &rt_test_data[thread_id].tx_timer,
 				       &tx_delay);
@@ -469,5 +469,5 @@
     if (rt_test_data[entry->id].tx_timer.user_data == NULL) {
 	pj_time_val delay = { 0, 0 };
-	rt_test_data[entry->id].tx_timer.user_data = (void*)1;
+	rt_test_data[entry->id].tx_timer.user_data = (void*)(pj_ssize_t)1;
 	pjsip_endpt_schedule_timer(endpt, &rt_test_data[entry->id].tx_timer,
 				   &delay);
@@ -586,5 +586,6 @@
 
 	/* Create thread, suspended. */
-	status = pj_thread_create(pool, "rttest%p", &rt_worker_thread, (void*)(long)i, 0,
+	status = pj_thread_create(pool, "rttest%p", &rt_worker_thread, 
+				  (void*)(pj_ssize_t)i, 0,
 				  PJ_THREAD_SUSPENDED, &rt_test_data[i].thread);
 	if (status != PJ_SUCCESS) {
@@ -600,5 +601,5 @@
 
 	/* Schedule first message transmissions. */
-	rt_test_data[i].tx_timer.user_data = (void*)1;
+	rt_test_data[i].tx_timer.user_data = (void*)(pj_ssize_t)1;
 	pjsip_endpt_schedule_timer(endpt, &rt_test_data[i].tx_timer, &delay);
     }
Index: /pjproject/trunk/pjsip/src/test/tsx_basic_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test/tsx_basic_test.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/test/tsx_basic_test.c	(revision 4537)
@@ -161,5 +161,5 @@
 struct tsx_test_state
 {
-    int pool_cnt;
+    pj_size_t pool_cnt;
 };
 
Index: /pjproject/trunk/pjsip/src/test/txdata_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test/txdata_test.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/test/txdata_test.c	(revision 4537)
@@ -432,5 +432,5 @@
     pjsip_parser_err_report err_list;
     pjsip_msg *msg;
-    int len;
+    pj_ssize_t len;
     pj_status_t status;
 
Index: /pjproject/trunk/pjsip/src/test/uri_test.c
===================================================================
--- /pjproject/trunk/pjsip/src/test/uri_test.c	(revision 4536)
+++ /pjproject/trunk/pjsip/src/test/uri_test.c	(revision 4537)
@@ -1040,5 +1040,6 @@
 	unsigned cmp;
     } run[COUNT];
-    unsigned i, max, avg_len;
+    unsigned i, max;
+    pj_ssize_t avg_len;
     char desc[200];
     pj_status_t status;
@@ -1075,10 +1076,10 @@
 			  "(tested with %d URI set, with average length of "
 			  "%d chars)",
-			  (int)PJ_ARRAY_SIZE(uri_test_array), avg_len);
+			  (int)PJ_ARRAY_SIZE(uri_test_array), (int)avg_len);
 
     report_ival("uri-parse-per-sec", max, "URI/sec", desc);
 
     /* URI parsing bandwidth */
-    report_ival("uri-parse-bandwidth-mb", avg_len*max/1000000, "MB/sec",
+    report_ival("uri-parse-bandwidth-mb", (int)avg_len*max/1000000, "MB/sec",
 	        "URI parsing bandwidth in megabytes (number of megabytes "
 		"worth of URI that can be parsed per second)");
@@ -1095,5 +1096,5 @@
 			  "(tested with %d URI set, with average length of "
 			  "%d chars)",
-			  (int)PJ_ARRAY_SIZE(uri_test_array), avg_len);
+			  (int)PJ_ARRAY_SIZE(uri_test_array), (int)avg_len);
 
     report_ival("uri-print-per-sec", max, "URI/sec", desc);
@@ -1109,5 +1110,5 @@
 			  "(tested with %d URI set, with average length of "
 			  "%d chars)",
-			  (int)PJ_ARRAY_SIZE(uri_test_array), avg_len);
+			  (int)PJ_ARRAY_SIZE(uri_test_array), (int)avg_len);
 
     report_ival("uri-cmp-per-sec", max, "URI/sec", desc);
